From 3d7b2c53b3fa45b8848369bfbc49a0c7e5854304 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Thu, 29 Jan 2026 19:47:26 +0700
Subject: [PATCH v9 14/26] Fixing error about freeing memory twice

---
 src/bin/pgbench/pgbench.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 3687b65871e..6f42438d970 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5462,6 +5462,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	for (int64_t i = start; i < start + base; i++)
 	{
+		res = PQgetResult(con);
 		init_row(con, res, i, base);
 	}
 
@@ -5473,7 +5474,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	sendBinaryCopyTrailer(con);
 
-
+	res = PQgetResult(con);
 	if (PQresultStatus(res) == PGRES_COPY_IN)
 	{
 		if (PQputCopyEnd(con, NULL) == 1) /* success */
@@ -5481,7 +5482,6 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 			res = PQgetResult(con);
 			if (PQresultStatus(res) != PGRES_COMMAND_OK)
 				fprintf(stderr, "Error: %s\n", PQerrorMessage(con));
-			PQclear(res);
 		}
 		else
 			fprintf(stderr, "Error: %s\n", PQerrorMessage(con));
-- 
2.43.0

